## mandos 1.8.18

=== Makefile ===
WARN:=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
	-Wunused -Wuninitialized -Wstrict-overflow=5 \
	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
	-Wsuggest-attribute=noreturn -Wfloat-equal -Wundef -Wshadow \
	-Wunsafe-loop-optimizations -Wpointer-arith \
	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
	-Wconversion -Wlogical-op -Waggregate-return \
	-Wstrict-prototypes -Wold-style-definition \
	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
	-Wredundant-decls -Wnested-externs -Winline -Wvla \
	-Wvolatile-register-var -Woverlength-strings

#DEBUG:=-ggdb3 -fsanitize=address $(SANITIZE)
## Check which sanitizing options can be used
#SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
#	echo 'int main(){}' | $(CC) --language=c $(option) \
#	/dev/stdin -o /dev/null >/dev/null 2>&1 && echo $(option)))
# <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
        -fsanitize=shift -fsanitize=integer-divide-by-zero \
        -fsanitize=unreachable -fsanitize=vla-bound -fsanitize=null \
        -fsanitize=return -fsanitize=signed-integer-overflow \
        -fsanitize=bounds -fsanitize=alignment \
        -fsanitize=object-size -fsanitize=float-divide-by-zero \
        -fsanitize=float-cast-overflow -fsanitize=nonnull-attribute \
        -fsanitize=returns-nonnull-attribute -fsanitize=bool \
        -fsanitize=enum -fsanitize-address-use-after-scope

# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
FORTIFY:=-fstack-protector-all -fPIC
CPPFLAGS+=-D_FORTIFY_SOURCE=3
LINK_FORTIFY_LD:=-z relro -z now
LINK_FORTIFY:=

# If BROKEN_PIE is set, do not build with -pie
ifndef BROKEN_PIE
FORTIFY += -fPIE
LINK_FORTIFY += -pie
endif
#COVERAGE=--coverage
OPTIMIZE:=-Os -fno-strict-aliasing
LANGUAGE:=-std=gnu11
CPPFLAGS+=-D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64
htmldir:=man
version:=1.8.18
SED:=sed
PKG_CONFIG?=pkg-config

USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos \
	|| getent passwd nobody || echo 65534)))
GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos \
	|| getent group nogroup || echo 65534)))

LINUXVERSION:=$(shell uname --kernel-release)

## Use these settings for a traditional /usr/local install
# PREFIX:=$(DESTDIR)/usr/local
# BINDIR:=$(PREFIX)/sbin
# CONFDIR:=$(DESTDIR)/etc/mandos
# KEYDIR:=$(DESTDIR)/etc/mandos/keys
# MANDIR:=$(PREFIX)/man
# INITRAMFSTOOLS:=$(DESTDIR)/etc/initramfs-tools
# DRACUTMODULE:=$(DESTDIR)/usr/lib/dracut/modules.d/90mandos
# STATEDIR:=$(DESTDIR)/var/lib/mandos
# LIBDIR:=$(PREFIX)/lib
# DBUSPOLICYDIR:=$(DESTDIR)/etc/dbus-1/system.d
##

## These settings are for a package-type install
PREFIX:=$(DESTDIR)/usr
BINDIR:=$(PREFIX)/sbin
CONFDIR:=$(DESTDIR)/etc/mandos
KEYDIR:=$(DESTDIR)/etc/keys/mandos
MANDIR:=$(PREFIX)/share/man
INITRAMFSTOOLS:=$(DESTDIR)/usr/share/initramfs-tools
DRACUTMODULE:=$(DESTDIR)/usr/lib/dracut/modules.d/90mandos
STATEDIR:=$(DESTDIR)/var/lib/mandos
LIBDIR:=$(shell \
	for d in \
	"/usr/lib/`dpkg-architecture \
			-qDEB_HOST_MULTIARCH 2>/dev/null`" \
	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
		if [ -d "$$d" -a "$$d" = "$${d%/}" ]; then \
			echo "$(DESTDIR)$$d"; \
			break; \
		fi; \
	done)
DBUSPOLICYDIR:=$(DESTDIR)/usr/share/dbus-1/system.d
##

SYSTEMD:=$(DESTDIR)$(shell $(PKG_CONFIG) systemd \
			--variable=systemdsystemunitdir)
TMPFILES:=$(DESTDIR)$(shell $(PKG_CONFIG) systemd \
			--variable=tmpfilesdir)
SYSUSERS:=$(DESTDIR)$(shell $(PKG_CONFIG) systemd \
			--variable=sysusersdir)

GNUTLS_CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I gnutls)
GNUTLS_LIBS:=$(shell $(PKG_CONFIG) --libs gnutls)
AVAHI_CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I avahi-core)
AVAHI_LIBS:=$(shell $(PKG_CONFIG) --libs avahi-core)
GPGME_CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I gpgme 2>/dev/null \
	|| gpgme-config --cflags; getconf LFS_CFLAGS)
GPGME_LIBS:=$(shell $(PKG_CONFIG) --libs gpgme 2>/dev/null \
	|| gpgme-config --libs; getconf LFS_LIBS; \
	getconf LFS_LDFLAGS)
LIBNL3_CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I libnl-route-3.0)
LIBNL3_LIBS:=$(shell $(PKG_CONFIG) --libs libnl-route-3.0)
GLIB_CFLAGS:=$(shell $(PKG_CONFIG) --cflags glib-2.0)
GLIB_LIBS:=$(shell $(PKG_CONFIG) --libs glib-2.0)

# Do not change these two
CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
	$(LANGUAGE) -DVERSION='"$(version)"'
LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(strip \
	) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))

# Commands to format a DocBook <refentry> document into a manual page
DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
	--param man.charmap.use.subset		0 \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
	$(notdir $<); \
	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
	&& command -v man >/dev/null; then LANG=en_US.UTF-8 \
	MANWIDTH=80 man --warnings --encoding=UTF-8 --local-file \
	$(notdir $@); fi >/dev/null)

DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	--param citerefentry.link		1 \
	--output $@ \
	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
	$<; $(HTMLPOST) $@)
# Fix citerefentry links
HTMLPOST:=$(SED) --in-place \
	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'

PLUGINS:=plugins.d/password-prompt plugins.d/mandos-client \
	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
	plugins.d/plymouth
PLUGIN_HELPERS:=plugin-helpers/mandos-client-iprouteadddel
CPROGS:=plugin-runner dracut-module/password-agent $(PLUGINS) \
	$(PLUGIN_HELPERS)
PROGS:=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
DOCS:=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
	dracut-module/password-agent.8mandos \
	plugins.d/mandos-client.8mandos \
	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
	plugins.d/plymouth.8mandos intro.8mandos

htmldocs:=$(addsuffix .xhtml,$(DOCS))

objects:=$(addsuffix .o,$(CPROGS))

.PHONY: all
all: $(PROGS) mandos.lsm

.PHONY: doc
doc: $(DOCS)

.PHONY: html
html: $(htmldocs)

%.5: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.5.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8mandos: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8mandos.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

intro.8mandos: intro.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
intro.8mandos.xhtml: intro.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.8.xhtml: mandos.xml common.ent mandos-options.xml \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-keygen.8: mandos-keygen.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-keygen.8.xhtml: mandos-keygen.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-monitor.8: mandos-monitor.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-monitor.8.xhtml: mandos-monitor.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-ctl.8: mandos-ctl.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-ctl.8.xhtml: mandos-ctl.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.conf.5: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.conf.5.xhtml: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOHTML)

plugin-runner.8mandos: plugin-runner.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
plugin-runner.8mandos.xhtml: plugin-runner.xml common.ent \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

dracut-module/password-agent.8mandos: \
		dracut-module/password-agent.xml common.ent \
		overview.xml legalnotice.xml
	$(DOCBOOKTOMAN)
dracut-module/password-agent.8mandos.xhtml: \
		dracut-module/password-agent.xml common.ent \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOMAN)
plugins.d/mandos-client.8mandos.xhtml: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

# Update all these files with version number $(version)
common.ent: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
		$@)

mandos: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-keygen: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-ctl: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-monitor: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos.lsm: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(Version:\).*/\1\t$(version)/' \
		$@)
	$(strip $(SED) --in-place \
		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
		$@)
	$(strip $(SED) --in-place \
		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
		$@)

# Does the linker support the --no-warn-execstack option?
ifeq ($(shell echo 'int main(){}'|$(CC) --language=c /dev/stdin -o /dev/null -Xlinker --no-warn-execstack >/dev/null 2>&1 && echo yes),yes)
# These programs use nested functions, which uses an executable stack
plugin-runner: LDFLAGS += -Xlinker --no-warn-execstack
dracut-module/password-agent: LDFLAGS += -Xlinker --no-warn-execstack
plugins.d/password-prompt: LDFLAGS += -Xlinker --no-warn-execstack
plugins.d/mandos-client: LDFLAGS += -Xlinker --no-warn-execstack
plugins.d/plymouth: LDFLAGS += -Xlinker --no-warn-execstack
endif

# Need to add the GnuTLS, Avahi and GPGME libraries
plugins.d/mandos-client: CFLAGS += $(GNUTLS_CFLAGS) $(strip \
	) $(AVAHI_CFLAGS) $(GPGME_CFLAGS)
plugins.d/mandos-client: LDLIBS += $(GNUTLS_LIBS) $(strip \
	) $(AVAHI_LIBS) $(GPGME_LIBS)

# Need to add the libnl-route library
plugin-helpers/mandos-client-iprouteadddel: CFLAGS += $(LIBNL3_CFLAGS)
plugin-helpers/mandos-client-iprouteadddel: LDLIBS += $(LIBNL3_LIBS)

# Need to add the GLib and pthread libraries
dracut-module/password-agent: CFLAGS += $(GLIB_CFLAGS)
# Note: -lpthread is unnecessary with the GNU C library 2.34 or later
dracut-module/password-agent: LDLIBS += $(GLIB_LIBS) -lpthread

.PHONY: clean
clean:
	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core

.PHONY: distclean
distclean: clean
.PHONY: mostlyclean
mostlyclean: clean
.PHONY: maintainer-clean
maintainer-clean: clean
	-rm --force --recursive keydir confdir statedir

.PHONY: check
check: all
	./mandos --check
	./mandos-ctl --check
	./mandos-keygen --version
	./plugin-runner --version
	./plugin-helpers/mandos-client-iprouteadddel --version
	./dracut-module/password-agent --test

# Run the client with a local config and key
.PHONY: run-client
run-client: all keydir/seckey.txt keydir/pubkey.txt \
			keydir/tls-privkey.pem keydir/tls-pubkey.pem

=== debian/changelog ===
mandos (1.8.18-1) unstable; urgency=medium

  * New upstream release.
  * debian/control (Source: mandos/Build-Depends): Fix lintian warning
    "build-depends-on-obsolete-package" by changing "pkg-config" to
    "pkgconf | pkg-config".
  * debian/mandos-client.lintian-overrides: Override experimental tag
    "executable-in-usr-lib" about files which are not actually executed
    from this location, and only exist to be copied to the initial RAM
    disk image.  Also the Dracut module-setup.sh file, which merely
    follows the pattern of all other Dracut module-setup.sh files from
    other Dracut modules.
  * debian/control (Package: mandos/Suggests): Add "python3 (>= 3.3)" and
    "python (<= 2.6)" as alternatives to "libc6-dev | libc-dev" and
    "c-compiler".  This avoids suggesting a C compiler unnecessarily.

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 24 Nov 2024 16:14:16 +0100

=== debian/control ===
Source: mandos
Section: admin
Priority: optional
Maintainer: Mandos Maintainers <mandos@recompile.se>
Uploaders: Teddy Hogeborn <teddy@recompile.se>,
	   Björn Påhlsson <belorn@recompile.se>
Build-Depends: debhelper (>= 10), docbook-xml, docbook-xsl,
	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
	libglib2.0-dev (>=2.40), libgnutls28-dev (>= 3.3.0),
	libgnutls28-dev (>= 3.6.6) | libgnutls28-dev (<< 3.6.0),
	xsltproc, pkgconf | pkg-config, libnl-route-3-dev,
	systemd-dev | systemd (<< 256~rc2-1)
Build-Depends-Indep: python3 (>= 3), python3-dbus, python3-gi,
	po-debconf
Standards-Version: 4.7.0
Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
Homepage: https://www.recompile.se/mandos
Rules-Requires-Root: binary-targets

Package: mandos
Architecture: all
Depends: ${misc:Depends}, python3 (>= 3),
	libgnutls30t64 | libgnutls30 (>= 3.3.0),
	libgnutls30t64 | libgnutls30 (>= 3.6.6) | libgnutls30 (<< 3.6.0),
	python3-dbus, python3-gi, avahi-daemon, adduser,
	python3-urwid, gnupg, systemd-sysv | lsb-base (>= 3.0-6),
	debconf (>= 1.5.5) | debconf-2.0
Recommends: ssh-client | fping
Suggests: python3 (>= 3.3) | libc6-dev | libc-dev | python (<= 2.6),
	python3 (>= 3.3) | c-compiler | python (<= 2.6)
Description: server giving encrypted passwords to Mandos clients
 This is the server part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using a TLS public
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using an OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

Package: mandos-client
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser,
	cryptsetup (<< 2:2.0.3-1) | cryptsetup-initramfs,
	initramfs-tools (>= 0.99) | dracut (>= 044+241-3),
	dpkg-dev (>=1.16.0),
	gnutls-bin (>= 3.6.6) | libgnutls30 (<< 3.6.0),
	debconf (>= 1.5.5) | debconf-2.0
Recommends: ssh
Breaks: dropbear (<= 0.53.1-1)
Enhances: cryptsetup
Conflicts: dracut-config-generic
Description: do unattended reboots with an encrypted root file system
 This is the client part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using a TLS public
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using an OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

## mandos 1.8.19

=== Makefile ===
--- 
+++ 
@@ -44,7 +44,7 @@
 LANGUAGE:=-std=gnu11
 CPPFLAGS+=-D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64
 htmldir:=man
-version:=1.8.18
+version:=1.8.19
 SED:=sed
 PKG_CONFIG?=pkg-config

=== debian/changelog ===
mandos (1.8.19-1) unstable; urgency=medium

  * New upstream release.
  * debian/control (Package: mandos/Suggests) Remove suggestion of old
    Python 2.6 (for IN.SO_BINDTODEVICE); it upsets package analysis
    tools to see references to Python 2.  (Closes: #1107761)
  * debian/control (Package: mandos-client/Depends): Add dependency on
    "systemd-cryptsetup" (for newer systemd), or "systemd (<< 256-2)" for
    when cryptsetup support was included in the systemd package itself, or
    "sysvinit-core" for installations without systemd.
  * debian/control (Standards-Version): Change to "4.7.2".

 -- Teddy Hogeborn <teddy@recompile.se>  Fri, 27 Jun 2025 22:04:18 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	systemd-dev | systemd (<< 256~rc2-1)
 Build-Depends-Indep: python3 (>= 3), python3-dbus, python3-gi,
 	po-debconf
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: https://www.recompile.se/mandos
@@ -27,8 +27,8 @@
 	python3-urwid, gnupg, systemd-sysv | lsb-base (>= 3.0-6),
 	debconf (>= 1.5.5) | debconf-2.0
 Recommends: ssh-client | fping
-Suggests: python3 (>= 3.3) | libc6-dev | libc-dev | python (<= 2.6),
-	python3 (>= 3.3) | c-compiler | python (<= 2.6)
+Suggests: python3 (>= 3.3) | libc6-dev | libc-dev,
+	python3 (>= 3.3) | c-compiler
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -51,7 +51,8 @@
 	initramfs-tools (>= 0.99) | dracut (>= 044+241-3),
 	dpkg-dev (>=1.16.0),
 	gnutls-bin (>= 3.6.6) | libgnutls30 (<< 3.6.0),
-	debconf (>= 1.5.5) | debconf-2.0
+	debconf (>= 1.5.5) | debconf-2.0,
+	systemd-cryptsetup | systemd (<< 256-2) | sysvinit-core
 Recommends: ssh
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += OPTIMIZE=-O0
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

PKG_CONFIG?=pkg-config

%:
	dh $@

override_dh_installdirs-indep:
	dh_installdirs
	dh_installdirs $(patsubst /%,%,$(shell $(PKG_CONFIG) \
		systemd --variable=systemdsystemunitdir)) \
		$(patsubst /%,%,$(shell $(PKG_CONFIG) \
		systemd --variable=tmpfilesdir)) \
		$(patsubst /%,%,$(shell $(PKG_CONFIG) \
		systemd --variable=sysusersdir))

override_dh_installdirs-arch:
	dh_installdirs
	dh_installdirs $(patsubst /%,%,$(shell $(PKG_CONFIG) \
		systemd --variable=sysusersdir))

override_dh_auto_build-arch:
	LC_ALL=en_US.utf8 dh_auto_build -- all doc

override_dh_auto_build-indep:
	LC_ALL=en_US.utf8 dh_auto_build -- doc

override_dh_installinit-indep:
	dh_installinit --onlyscripts \
		--update-rcd-params="defaults 25 15"

override_dh_auto_install-indep:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server

override_dh_auto_install-arch:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client \
		install-client-nokey

override_dh_fixperms-arch:
	dh_fixperms --exclude etc/keys/mandos \
		--exclude etc/mandos/plugins.d \
		--exclude etc/mandos/plugin-helpers \
		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugins.d \
		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugin-helpers \
		--exclude usr/share/doc/mandos-client/examples/network-hooks.d/
	chmod --recursive g-w -- \
	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"

override_dh_fixperms-indep:
	dh_fixperms --exclude etc/mandos/clients.conf

override_dh_auto_test-arch: ;

#bpo## dpkg-shlibdeps sees the "libgnutls28-dev (>= 3.6.6) |
#bpo## libgnutls28-dev (<< 3.6.0)," in the build-dependencies not as two
#bpo## alternatives, but as an absolute dependency on libgnutls30 >= 3.6.6.
#bpo## So we have to do this ugly hack to hide this build dependency if we
#bpo## compiled with libgnutls30 << 3.6.0.
#bpo#override_dh_shlibdeps-arch:
#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
#bpo#		--show libgnutls30); \
#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
#bpo#		&& { cp --archive debian/control debian/control.orig; sed --in-place --expression='s/libgnutls28-dev (>= 3\.6\.6) |//' debian/control; }
#bpo#	dh_shlibdeps
#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
#bpo#		--show libgnutls30); \
#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
#bpo#		&& mv debian/control.orig debian/control

=== debian/tests/control ===
Test-Command: /usr/sbin/mandos --check
Restrictions: superficial, allow-stderr
Features: test-name=mandos-check
Depends: mandos

Test-Command: /usr/sbin/mandos-ctl --check --verbose
Restrictions: allow-stderr
Features: test-name=mandos-ctl
Depends: mandos

Test-Command: /usr/sbin/mandos-keygen --version
Restrictions: superficial
Features: test-name=mandos-keygen-version
Depends: mandos-client

Test-Command: /usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-runner --version
Restrictions: needs-root, superficial
Features: test-name=plugin-runner-version
Depends: mandos-client

Test-Command: /usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers/mandos-client-iprouteadddel --version
Restrictions: needs-root, superficial
Features: test-name=mandos-client-iprouteadddel-version
Depends: mandos-client

Test-Command: /usr/lib/dracut/modules.d/90mandos/password-agent --test --verbose
Features: test-name=password-agent
Depends: mandos-client

Test-Command: /usr/lib/dracut/modules.d/90mandos/password-agent --test --verbose -p /task-creators/start_mandos_client/suid
Restrictions: needs-root
Features: test-name=password-agent-suid
Depends: mandos-client
